/**
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

package fixtures.paging.models;

import com.fasterxml.jackson.annotation.JsonProperty;

/**
 * Additional parameters for the getMultiplePagesWithOffset operation.
 */
public class PagingGetMultiplePagesWithOffsetOptions {
    /**
     * Sets the maximum number of items to return in the response.
     */
    @JsonProperty(value = "")
    private Integer maxresults;

    /**
     * Offset of return value.
     */
    @JsonProperty(value = "", required = true)
    private int offset;

    /**
     * Sets the maximum time that the server can spend processing the request,
     * in seconds. The default is 30 seconds.
     */
    @JsonProperty(value = "")
    private Integer timeout;

    /**
     * Get the maxresults value.
     *
     * @return the maxresults value
     */
    public Integer getMaxresults() {
        return this.maxresults;
    }

    /**
     * Set the maxresults value.
     *
     * @param maxresults the maxresults value to set
     */
    public void setMaxresults(Integer maxresults) {
        this.maxresults = maxresults;
    }

    /**
     * Get the offset value.
     *
     * @return the offset value
     */
    public int getOffset() {
        return this.offset;
    }

    /**
     * Set the offset value.
     *
     * @param offset the offset value to set
     */
    public void setOffset(int offset) {
        this.offset = offset;
    }

    /**
     * Get the timeout value.
     *
     * @return the timeout value
     */
    public Integer getTimeout() {
        return this.timeout;
    }

    /**
     * Set the timeout value.
     *
     * @param timeout the timeout value to set
     */
    public void setTimeout(Integer timeout) {
        this.timeout = timeout;
    }

}
